﻿Import "-stdlib=libc++ -mmacosx-version-min=10.7" : EndImport

Global ScriptJS.s = #Null$, StackedBars.s = #Null$

Procedure ButtonHandler()
  ScriptJS_Random.s = #TAB$ + "<script type='text/javascript'>" + #LF$ +
                      #TAB$ + #TAB$ + "var nLayer = 0," + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + "nLayers = " + GetGadgetText(3) + "," + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + "nSamples = " + GetGadgetText(4) + "," + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + "stack = d3.layout.stack()," + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + "layers = stack(d3.range(nLayers).map(function() { return getValues(nSamples, nLayer = nLayer + 1); }))," + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + "yGroupMax = d3.max(layers, function(layer) { return d3.max(layer, function(d) { return d.y; }); })," + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + "yStackMax = d3.max(layers, function(layer) { return d3.max(layer, function(d) { return d.y0 + d.y; }); });" + #LF$ +
                      #TAB$ + #TAB$ + "var margin = {top: 40, right: 10, bottom: 20, left: 10}," + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + "width = 960 - margin.left - margin.right," + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + "height = 500 - margin.top - margin.bottom;" + #LF$ +
                      #TAB$ + #TAB$ + "var x = d3.scale.ordinal()" + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + ".domain(d3.range(nSamples))" + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + ".rangeRoundBands([0, width], .08);" + #LF$ +
                      #TAB$ + #TAB$ + "var y = d3.scale.linear()" + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + ".domain([0, yStackMax])" + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + ".range([height, 0]);" + #LF$ +
                      #TAB$ + #TAB$ + "var color = d3.scale.linear()" + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + ".domain([0, nLayers - 1])" + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + ".range(['#aad', '#556']);" + #LF$ +
                      #TAB$ + #TAB$ + "var xAxis = d3.svg.axis()" + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + ".scale(x)" + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + ".tickSize(0)" + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + ".tickPadding(6)" + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + ".orient('bottom');" + #LF$ +
                      #TAB$ + #TAB$ + "var svg = d3.select('body').append('svg')" + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + ".attr('width', width + margin.left + margin.right)" + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + ".attr('height', height + margin.top + margin.bottom)" + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + ".append('g')" + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + ".attr('transform', 'translate(' + margin.left + ',' + margin.top + ')');" + #LF$ +
                      #TAB$ + #TAB$ + "var layer = svg.selectAll('.layer')" + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + ".data(layers)" + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + ".enter().append('g')" + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + ".attr('class', 'layer')" + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + ".style('fill', function(d, i) { return color(i); });" + #LF$ +
                      #TAB$ + #TAB$ + "var rect = layer.selectAll('rect')" + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + ".data(function(d) { return d; })" + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + ".enter().append('rect')" + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + ".attr('x', function(d) { return x(d.x); })" + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + ".attr('y', height)" + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + ".attr('width', x.rangeBand())" + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + ".attr('height', 0);" + #LF$ +
                      #TAB$ + #TAB$ + "rect.transition()" + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + ".delay(function(d, i) { return i * 10; })" + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + ".attr('y', function(d) { return y(d.y0 + d.y); })" + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + ".attr('height', function(d) { return y(d.y0) - y(d.y0 + d.y); });" + #LF$ +
                      #TAB$ + #TAB$ + "svg.append('g')" + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + ".attr('class', 'x axis')" + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + ".attr('transform', 'translate(0,' + height + ')')" + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + ".call(xAxis);" + #LF$ +
                      #TAB$ + #TAB$ + "d3.selectAll('input').on('change', change);" + #LF$ +
                      #TAB$ + #TAB$ + "var timeout = setTimeout(function() {" + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + "d3.select('input[value=\'grouped\']').property('checked', true).each(change);" + #LF$ +
                      #TAB$ + #TAB$ + "}, 2000);" + #LF$ +
                      #TAB$ + #TAB$ + "function change() {" + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + "clearTimeout(timeout);" + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + "if (this.value === 'grouped') transitionGrouped();" + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + "else transitionStacked();" + #LF$ +
                      #TAB$ + #TAB$ + "}" + #LF$ +
                      #TAB$ + #TAB$ + "function transitionGrouped() {" + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + "y.domain([0, yGroupMax]);" + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + "rect.transition()" + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + #TAB$ + ".duration(500)" + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + #TAB$ + ".delay(function(d, i) { return i * 10; })" + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + #TAB$ + ".attr('x', function(d, i, j) { return x(d.x) + x.rangeBand() / nLayers * j; })" + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + #TAB$ + ".attr('width', x.rangeBand() / nLayers)" + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + #TAB$ + ".transition()" + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + #TAB$ + ".attr('y', function(d) { return y(d.y); })" + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + #TAB$ + ".attr('height', function(d) { return height - y(d.y); });" + #LF$ +
                      #TAB$ + #TAB$ + "}" + #LF$ +
                      #TAB$ + #TAB$ + "function transitionStacked() {" + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + "y.domain([0, yStackMax]);" + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + "rect.transition()" + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + #TAB$ + ".duration(500)" + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + #TAB$ + ".delay(function(d, i) { return i * 10; })" + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + #TAB$ + ".attr('y', function(d) { return y(d.y0 + d.y); })" + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + #TAB$ + ".attr('height', function(d) { return y(d.y0) - y(d.y0 + d.y); })" + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + #TAB$ + ".transition()" + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + #TAB$ + ".attr('x', function(d) { return x(d.x); })" + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + #TAB$ + ".attr('width', x.rangeBand());" + #LF$ +
                      #TAB$ + #TAB$ + "}" + #LF$ +
                      #TAB$ + #TAB$ + "function getValues(nSamples, nLayer) {" + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + "var a = [], i;" + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + "for (i = 0; i < nSamples; ++i) a[i] = nLayer;" + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + "return a.map(function(d, i) { return {x: i, y: Math.random() * 50 + 10}; });" + #LF$ +
                      #TAB$ + #TAB$ + "}" + #LF$ +
                      #TAB$ + "</script>" + #LF$
  StackedBars = ReplaceString(StackedBars, ScriptJS, ScriptJS_Random)
  SetGadgetItemText(0, #PB_Web_HtmlCode, StackedBars)
  ScriptJS = ScriptJS_Random
EndProcedure

Procedure BuildDocument(D3JSFolder.s)
  If OpenWindow(0, 0, 0, 960, 600, "D3-JS: Stacked Bars", #PB_Window_SystemMenu | #PB_Window_ScreenCentered | #PB_Window_Invisible)
    WebGadget(0, 0, 80, 960, 520, #Null$)
    CocoaMessage(0, CocoaMessage(0, GadgetID(0), "preferences"), "setJavaScriptEnabled:", #YES)
    CocoaMessage(0, CocoaMessage(0, GadgetID(0), "preferences"), "setWebSecurityEnabled:", #NO)
    TextGadget(1, 120, 16, 50, 20, "Layers", #PB_Text_Right)
    TextGadget(2, 120, 48, 50, 20, "Samples", #PB_Text_Right)
    SpinGadget(3, 180, 12, 60, 25, 1, 10, #PB_Spin_ReadOnly | #PB_Spin_Numeric) : SetGadgetColor(3, #PB_Gadget_BackColor, $F0F0F0) : SetGadgetText(3, "3")
    SpinGadget(4, 180, 45, 60, 25, 1, 51, #PB_Spin_ReadOnly | #PB_Spin_Numeric) : SetGadgetColor(4, #PB_Gadget_BackColor, $F0F0F0) : SetGadgetText(4, "21")
    ButtonGadget(5, 320, 20, 200, 40, "Generate Random Data")
    SetGadgetAttribute(0, #PB_Web_BlockPopupMenu, #True)
    SetGadgetAttribute(0, #PB_Web_BlockPopups, #True)
    ScriptJS = "/*JHPJHP*/" : IncludeFile "Includes/d3js_stackedbars.pbi"
    ButtonHandler() : BindGadgetEvent(5, @ButtonHandler())
    StickyWindow(0, 1) : HideWindow(0, 0)
    Repeat : Until WaitWindowEvent() = #PB_Event_CloseWindow
  EndIf
EndProcedure

UseJPEGImageEncoder()
D3JSFolder.s = GetCurrentDirectory()
BuildDocument(D3JSFolder)
; IDE Options = PureBasic 5.60 (Windows - x86)
; CursorPosition = 1
; Folding = -
; UseIcon = Binaries/d3js.icns
; DisableDebugger
; EnableUnicode