﻿Import "-stdlib=libc++ -mmacosx-version-min=10.7" : EndImport

Global RealTime.s = #Null$

Procedure ButtonHandler()
  SetGadgetItemText(0, #PB_Web_HtmlCode, RealTime)
EndProcedure

Procedure BuildChart(FlotFolder.s)
  If OpenWindow(0, 0, 0, 960, 590, "HTML5 Flot: RealTime", #PB_Window_SystemMenu | #PB_Window_ScreenCentered | #PB_Window_Invisible)
    WebGadget(0, 0, 0, 960, 590, #Null$)
    CocoaMessage(0, CocoaMessage(0, GadgetID(0), "preferences"), "setJavaScriptEnabled:", #YES)
    CocoaMessage(0, CocoaMessage(0, GadgetID(0), "preferences"), "setWebSecurityEnabled:", #NO)
    ButtonGadget(1, 320, 22, 200, 40, "Generate Random Data")
    SetGadgetAttribute(0, #PB_Web_BlockPopupMenu, #True)
    SetGadgetAttribute(0, #PB_Web_BlockPopups, #True)
    IncludeFile "Includes/flot_realtime.pbi"
    ButtonHandler() : BindGadgetEvent(1, @ButtonHandler())
    StickyWindow(0, 1) : HideWindow(0, 0)
    Repeat : Until WaitWindowEvent() = #PB_Event_CloseWindow
  EndIf
EndProcedure

UseJPEGImageEncoder()
FlotFolder.s = GetCurrentDirectory()
BuildChart(FlotFolder)
; IDE Options = PureBasic 5.60 (Windows - x86)
; CursorPosition = 1
; Folding = -
; UseIcon = Binaries/chart.icns
; DisableDebugger
; EnableUnicode