﻿Import "-stdlib=libc++ -mmacosx-version-min=10.7" : EndImport

Global ScriptJS.s = #Null$, Selection.s = #Null$

Procedure ButtonHandler()
  SelectionData.s = "["

  For rtnCount = 0 To 24 * 7 - 1
    SelectionData + "[" + Str(Date() + nTime) + "000," + Str(Random(5000)) + "],"
    nTime + 60 * 60
  Next
  SelectionData = Left(SelectionData, Len(SelectionData) - 1) + "]"
  ScriptJS_Random.s = #TAB$ + #TAB$ + "<script type='text/javascript'>" + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + "function getValues(){" + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + #TAB$ + "return " + SelectionData + ";" + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + "}" + #LF$ +
                      #TAB$ + #TAB$ + "</script>" + #LF$
  Selection = ReplaceString(Selection, ScriptJS, ScriptJS_Random)
  SetGadgetItemText(0, #PB_Web_HtmlCode, Selection)
  ScriptJS = ScriptJS_Random
EndProcedure

Procedure BuildChart(FlotFolder.s)
  If OpenWindow(0, 0, 0, 960, 760, "HTML5 Flot: Selection", #PB_Window_SystemMenu | #PB_Window_ScreenCentered | #PB_Window_Invisible)
    WebGadget(0, 0, 0, 960, 760, #Null$)
    CocoaMessage(0, CocoaMessage(0, GadgetID(0), "preferences"), "setJavaScriptEnabled:", #YES)
    CocoaMessage(0, CocoaMessage(0, GadgetID(0), "preferences"), "setWebSecurityEnabled:", #NO)
    ButtonGadget(1, 320, 22, 200, 40, "Generate Random Data")
    SetGadgetAttribute(0, #PB_Web_BlockPopupMenu, #True)
    SetGadgetAttribute(0, #PB_Web_BlockPopups, #True)
    ScriptJS = "/*JHPJHP*/" : IncludeFile "Includes/flot_selection.pbi"
    ButtonHandler() : BindGadgetEvent(1, @ButtonHandler())
    StickyWindow(0, 1) : HideWindow(0, 0)
    Repeat : Until WaitWindowEvent() = #PB_Event_CloseWindow
  EndIf
EndProcedure

UseJPEGImageEncoder()
FlotFolder.s = GetCurrentDirectory()
BuildChart(FlotFolder)
; IDE Options = PureBasic 5.60 (Windows - x86)
; CursorPosition = 1
; Folding = -
; UseIcon = Binaries/chart.icns
; DisableDebugger
; EnableUnicode