﻿Import "-stdlib=libc++ -mmacosx-version-min=10.7" : EndImport

Global ScriptJS.s = #Null$, PieChart.s = #Null$

Procedure ButtonHandler()
  SetGadgetItemText(1, 0, "Series 1") : SetGadgetItemText(1, 0, Str(Random(200, 20)), 1)
  SetGadgetItemText(1, 1, "Series 2") : SetGadgetItemText(1, 1, Str(Random(200, 20)), 1)
  SetGadgetItemText(1, 2, "Series 3") : SetGadgetItemText(1, 2, Str(Random(200, 20)), 1)
  SetGadgetItemText(1, 3, "Series 4") : SetGadgetItemText(1, 3, Str(Random(200, 20)), 1)
  SetGadgetItemText(1, 4, "Series 5") : SetGadgetItemText(1, 4, Str(Random(200, 20)), 1)
  SetGadgetItemText(1, 5, "Series 6") : SetGadgetItemText(1, 5, Str(Random(200, 20)), 1)
  ScriptJS_Random.s = #TAB$ + #TAB$ + "<script type='text/javascript'>" + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + "var data=[" + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + #TAB$ + "{label:'Series 1',data:" + GetGadgetItemText(1, 0, 1) + "}," + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + #TAB$ + "{label:'Series 2',data:" + GetGadgetItemText(1, 1, 1) + "}," + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + #TAB$ + "{label:'Series 3',data:" + GetGadgetItemText(1, 2, 1) + "}," + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + #TAB$ + "{label:'Series 4',data:" + GetGadgetItemText(1, 3, 1) + "}," + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + #TAB$ + "{label:'Series 5',data:" + GetGadgetItemText(1, 4, 1) + "}," + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + #TAB$ + "{label:'Series 6',data:" + GetGadgetItemText(1, 5, 1) + "}," + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + "];" + #LF$ +
                      #TAB$ + #TAB$ + "</script>" + #LF$
  PieChart = ReplaceString(PieChart, ScriptJS, ScriptJS_Random)
  SetGadgetItemText(0, #PB_Web_HtmlCode, PieChart)
  ScriptJS = ScriptJS_Random
EndProcedure

Procedure BuildChart(FlotFolder.s)
  If OpenWindow(0, 0, 0, 960, 600, "HTML5 Flot: Pie Chart", #PB_Window_SystemMenu | #PB_Window_ScreenCentered | #PB_Window_Invisible)
    WebGadget(0, 0, 0, 960, 600, #Null$)
    CocoaMessage(0, CocoaMessage(0, GadgetID(0), "preferences"), "setJavaScriptEnabled:", #YES)
    CocoaMessage(0, CocoaMessage(0, GadgetID(0), "preferences"), "setWebSecurityEnabled:", #NO)
    ListIconGadget(1, 410, 20, 202, 80, "Label", 120, #PB_ListIcon_FullRowSelect | #PB_ListIcon_AlwaysShowSelection)
    ButtonGadget(2, 680, 40, 200, 40, "Generate Random Data")
    SetGadgetAttribute(0, #PB_Web_BlockPopupMenu, #True)
    SetGadgetAttribute(0, #PB_Web_BlockPopups, #True)
    AddGadgetColumn(1, 2, "Data", 60)
    AddGadgetItem(1, 0, "Series 1" + Chr(10) + Str(Random(200, 20)))
    AddGadgetItem(1, 1, "Series 2" + Chr(10) + Str(Random(200, 20)))
    AddGadgetItem(1, 2, "Series 3" + Chr(10) + Str(Random(200, 20)))
    AddGadgetItem(1, 3, "Series 4" + Chr(10) + Str(Random(200, 20)))
    AddGadgetItem(1, 4, "Series 5" + Chr(10) + Str(Random(200, 20)))
    AddGadgetItem(1, 5, "Series 6" + Chr(10) + Str(Random(200, 20)))
    SetGadgetItemState(1, 0, 1)
    ScriptJS = "/*JHPJHP*/" : IncludeFile "Includes/flot_piechart.pbi"
    ButtonHandler() : BindGadgetEvent(2, @ButtonHandler())
    StickyWindow(0, 1) : HideWindow(0, 0)
    Repeat : Until WaitWindowEvent() = #PB_Event_CloseWindow
  EndIf
EndProcedure

UseJPEGImageEncoder()
FlotFolder.s = GetCurrentDirectory()
BuildChart(FlotFolder)
; IDE Options = PureBasic 5.60 (Windows - x86)
; CursorPosition = 1
; Folding = -
; UseIcon = Binaries/chart.icns
; DisableDebugger
; EnableUnicode