﻿Import "-stdlib=libc++ -mmacosx-version-min=10.7" : EndImport

Global ScriptJS.s = #Null$, StackChart.s = #Null$

Procedure ButtonHandler()
  StackData1.s = "["

  For rtnCount = 0 To 10
    StackData1 + "[" + Str(rtnCount) + "," + Str(Random(30)) + "],"
  Next
  StackData1 = Left(StackData1, Len(StackData1) - 1) + "]"
  StackData2.s = "["

  For rtnCount = 0 To 10
    StackData2 + "[" + Str(rtnCount) + "," + Str(Random(30)) + "],"
  Next
  StackData2 = Left(StackData2, Len(StackData2) - 1) + "]"
  StackData3.s = "["

  For rtnCount = 0 To 10
    StackData3 + "[" + Str(rtnCount) + "," + Str(Random(30)) + "],"
  Next
  StackData3 = Left(StackData3, Len(StackData3) - 1) + "]"
  ScriptJS_Random.s = #TAB$ + #TAB$ + "<script type='text/javascript'>" + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + "function getValues1(){" + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + #TAB$ + "return " + StackData1 + ";" + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + "}" + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + "function getValues2(){" + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + #TAB$ + "return " + StackData2 + ";" + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + "}" + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + "function getValues3(){" + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + #TAB$ + "return " + StackData3 + ";" + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + "}" + #LF$ +
                      #TAB$ + #TAB$ + "</script>" + #LF$
  StackChart = ReplaceString(StackChart, ScriptJS, ScriptJS_Random)
  SetGadgetItemText(0, #PB_Web_HtmlCode, StackChart)
  ScriptJS = ScriptJS_Random
EndProcedure

Procedure BuildChart(FlotFolder.s)
  If OpenWindow(0, 0, 0, 960, 690, "HTML5 Flot: Stack Chart", #PB_Window_SystemMenu | #PB_Window_ScreenCentered | #PB_Window_Invisible)
    WebGadget(0, 0, 0, 960, 690, #Null$)
    CocoaMessage(0, CocoaMessage(0, GadgetID(0), "preferences"), "setJavaScriptEnabled:", #YES)
    CocoaMessage(0, CocoaMessage(0, GadgetID(0), "preferences"), "setWebSecurityEnabled:", #NO)
    ButtonGadget(1, 350, 22, 200, 40, "Generate Random Data")
    SetGadgetAttribute(0, #PB_Web_BlockPopupMenu, #True)
    SetGadgetAttribute(0, #PB_Web_BlockPopups, #True)
    ScriptJS = "/*JHPJHP*/" : IncludeFile "Includes/flot_stackchart.pbi"
    ButtonHandler() : BindGadgetEvent(1, @ButtonHandler())
    StickyWindow(0, 1) : HideWindow(0, 0)
    Repeat : Until WaitWindowEvent() = #PB_Event_CloseWindow
  EndIf
EndProcedure

UseJPEGImageEncoder()
FlotFolder.s = GetCurrentDirectory()
BuildChart(FlotFolder)
; IDE Options = PureBasic 5.60 (Windows - x86)
; CursorPosition = 1
; Folding = -
; UseIcon = Binaries/chart.icns
; DisableDebugger
; EnableUnicode