﻿Import "-stdlib=libc++ -mmacosx-version-min=10.7" : EndImport

Global ScriptJS.s = #Null$, Threshold.s = #Null$

Procedure ButtonHandler()
  ThresholdData.s = "["

  For rtnCount = 0 To 60
    ThresholdData + "[" + Str(rtnCount) + "," + Str(Random(100) - 50) + "],"
  Next
  ThresholdData = Left(ThresholdData, Len(ThresholdData) - 1) + "]"
  ScriptJS_Random.s = #TAB$ + #TAB$ + "<script type='text/javascript'>" + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + "function getValues(){" + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + #TAB$ + "return " + ThresholdData + ";" + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + "}" + #LF$ +
                      #TAB$ + #TAB$ + "</script>" + #LF$
  Threshold = ReplaceString(Threshold, ScriptJS, ScriptJS_Random)
  SetGadgetItemText(0, #PB_Web_HtmlCode, Threshold)
  ScriptJS = ScriptJS_Random
EndProcedure

Procedure BuildChart(FlotFolder.s)
  If OpenWindow(0, 0, 0, 960, 630, "HTML5 Flot: Threshold", #PB_Window_SystemMenu | #PB_Window_ScreenCentered | #PB_Window_Invisible)
    WebGadget(0, 0, 0, 960, 630, #Null$)
    CocoaMessage(0, CocoaMessage(0, GadgetID(0), "preferences"), "setJavaScriptEnabled:", #YES)
    CocoaMessage(0, CocoaMessage(0, GadgetID(0), "preferences"), "setWebSecurityEnabled:", #NO)
    ButtonGadget(1, 320, 22, 200, 40, "Generate Random Data")
    SetGadgetAttribute(0, #PB_Web_BlockPopupMenu, #True)
    SetGadgetAttribute(0, #PB_Web_BlockPopups, #True)
    ScriptJS = "/*JHPJHP*/" : IncludeFile "Includes/flot_threshold.pbi"
    ButtonHandler() : BindGadgetEvent(1, @ButtonHandler())
    StickyWindow(0, 1) : HideWindow(0, 0)
    Repeat : Until WaitWindowEvent() = #PB_Event_CloseWindow
  EndIf
EndProcedure

UseJPEGImageEncoder()
FlotFolder.s = GetCurrentDirectory()
BuildChart(FlotFolder)
; IDE Options = PureBasic 5.60 (Windows - x86)
; CursorPosition = 1
; Folding = -
; UseIcon = Binaries/chart.icns
; DisableDebugger
; EnableUnicode