$(function() {

	var d1 = getValues1();
	var d2 = getValues2();
	var d3 = getValues3();
	
	var stack = 0,
		bars = true,
		lines = false,
		steps = false;

	function plotWithOptions() {
		$.plot("#placeholder", [ d1, d2, d3 ], {
			series: {
				stack: stack,
				lines: {
					show: lines,
					fill: true,
					steps: steps
				},
				bars: {
					show: bars,
					barWidth: 0.6
				}
			}
		});
	}

	plotWithOptions();

	$(".stackControls button").click(function (e) {
		e.preventDefault();
		stack = $(this).text() == "With Stacking" ? true : null;
		plotWithOptions();
	});

	$(".graphControls button").click(function (e) {
		e.preventDefault();
		bars = $(this).text().indexOf("Bars") != -1;
		steps = $(this).text().indexOf("Steps") != -1;
		if(steps == true) {
			lines = true;
		} else {
			lines = $(this).text().indexOf('Lines') != -1;
		}
		plotWithOptions();
	});
});